//
// MPC2515 WX^`(rbgEtB[h)
// 		copyright (c) 2008,2009 T.Nakao
//
// 	08/12/28
//

#ifndef MCP2515REGTAG_H
#define MCP2515REGTAG_H

// -----------------------------------------
// MCP2515 WX^\̃^O
// -----------------------------------------

// CNF1 RtBM[V1WX^ (0x2A)
struct tag_CNF1 {
	unsigned char BRP:6;		// b0-b5
	unsigned char SJW0:1;		// b6
	unsigned char SJW1:1;		// b7
};

// CNF2 RtBM[V2WX^ (0x29)
struct tag_CNF2 {
	unsigned char PRSEG:3;	// b0-b2
	unsigned char PHSEG1:3;	// b3-b5
	unsigned char SAM:1;		// b6
	unsigned char BTLMODE:1;	// b7
};

// CNF3 RtBM[V3WX^ (0x28)
struct tag_CNF3 {
	unsigned char PHSEG2:3;	// b0-b2
	unsigned char b3:1;		// b3
	unsigned char b4:1;		// b4
	unsigned char b5:1;		// b5
	unsigned char WAKFIL:1;	// b6
	unsigned char SOF:1;		// b7
};

// CANCTRL CANRg[EWX^ (0xXF)
struct tag_CANCTRL {
	unsigned char CLKPRE:2;	// b0-b1
	unsigned char CLKEN:1;	// b2
	unsigned char OSM:1;		// b3
	unsigned char ABAT:1;		// b4
	unsigned char REQOP:3;	// b5-b7
};

// CANSTAT CANXe[^XEWX^ (0xXE)
struct tag_CANSTAT {
	unsigned char b0:1;		// b0
	unsigned char ICOD:3;		// b1-b3
	unsigned char b4:1;		// b4
	unsigned char OPMOD:3;	// b5-b7
};

// CANINTE 荞݋WX^ (0x2B)
struct tag_CANINTE {
	unsigned char RX0IE:1;	// b0
	unsigned char RX1IE:1;	// b1
	unsigned char TX0IE:1;	// b2
	unsigned char TX1IE:1;	// b3
	unsigned char TX2IE:1;	// b4
	unsigned char ERRIE:1;	// b5
	unsigned char WAKIE:1;	// b6
	unsigned char MERRE:1;	// b7
};

// CANINTF 荞݃tOEWX^ (0x2C)
struct tag_CANINTF {
	unsigned char RX0IF:1;	// b0
	unsigned char RX1IF:1;	// b1
	unsigned char TX0IF:1;	// b2
	unsigned char TX1IF:1;	// b3
	unsigned char TX2IF:1;	// b4
	unsigned char ERRIF:1;	// b5
	unsigned char WAKIF:1;	// b6
	unsigned char MERRF:1;	// b7
};

// EFLG G[EtO (0x2D)
struct tag_EFLG {
	unsigned char EWARN:1;	// b0
	unsigned char RXWAR:1;	// b1
	unsigned char TXWAR:1;	// b2
	unsigned char RXEP:1;		// b3
	unsigned char TXEP:1;		// b4
	unsigned char TXBO:1;		// b5
	unsigned char RX0OVR:1;	// b6
	unsigned char RX1OVR:1;	// b7
};

// TXBnCTRL Mobt@n Rg[EWX^ (n = 0, 1, 2) (0x30, 0x40, 0x50)
struct tag_TXBnCTRL {
	unsigned char TXP:2;		// b0-b1
	unsigned char b2:1;		// b2
	unsigned char TXREQ:1;	// b3
	unsigned char TXERR:1;	// b4
	unsigned char MLOA:1;		// b5
	unsigned char ABTF:1;		// b6
	unsigned char b7:1;		// b7
};

// TXBnDLC Mobt@n DLCWX^(n = 0, 1, 2) (0x35, 0x45, 0x55)
struct tag_TXBnDLC {
	unsigned char	DLC:4;		// b0-b3
	unsigned char	b4:1;		// b4
	unsigned char	b5:1;		// b5
	unsigned char	RTR:1;		// b6
	unsigned char	b7:1;		// b7
};

// RXB0CTRL Mobt@0 Rg[EWX^ (0x60)
struct tag_RXB0CTRL {
	unsigned char FILHIT0:1;	// b0
	unsigned char BUKT1:1;	// b1
	unsigned char BUKT:1;		// b2
	unsigned char RXRTR:1;	// b3
	unsigned char b4:1;		// b4
	unsigned char RXM:2;		// b5-b6
	unsigned char b7:1;		// b7
};

// RXBnDLC Mobt@n DLCWX^(n = 0, 1) (0x65, 0x75)
struct tag_RXBnDLC {
	unsigned char DLC:4;		// b0-b3
	unsigned char RB0:1;		// b4
	unsigned char RB1:1;		// b5
	unsigned char RTR:1;		// b6
	unsigned char b7:1;		// b7
};

// RXB1CTRL Mobt@1 Rg[EWX^ (0x70)
struct tag_RXB1CTRL {
	unsigned char FILHIT:3;	// b0-b2
	unsigned char RXRTR:1;	// b3
	unsigned char b4:1;		// b4
	unsigned char RXM:2;		// b5-b6
	unsigned char b7:1;		// b7
};

#endif
